;Ultimate Boom Boom by Darolac

!jump = $C0					; jump height. Lower values means higher jumps.

!random = 1						; if this is set it will make the Boom Boom change direction in an unpredictable way when it's about to take fly, in order to avoid players abusing the fact
								; that the Boom Boom can be jumped on easily those first frames of flight.
	
!bobnumber = $02 ; number of bob-ombs/mini Boom Booms that it throws before ramming at Mario, while flying.	
!bobnumber2 = $04 ; number of bob-ombs/mini Boom Booms that it throws before ramming at Mario, while flying, when it's the last hit.
!spritenumber = $00
!GoalTile = $8C					;Goal Tile
!GoalProp = $0D					;Palette E, SP4
!GoalMusic = $0B				;Goal Music
!timer = $38					;Bob-Omb timer
!BobOmbXSpeed = $18				; X speed with which the bob-ombs are thrown during the phase transition.

!RiseLoc = $00F0				;Do NOT touch!

MaxSpeedRam:
	db $10,-$10
FireXSpeed:
	db $06,-$06,$0C,-$0C
FireYSpeed:
	db $EB,$EB,$F0,$F0	
SpriteXSpeed:
	db !BobOmbXSpeed,-!BobOmbXSpeed
SpriteYSpeed:
	db $E0,$E0
Randomphases:
	db $02,$01,$02,$01,$02,$01,$02,$01
Healthphases:
	db $00,$01,$02,$01,$02,$01,$02,$01,$02,$01,$02,$01,$02,$01,$02,$01
YSpeedtable:
	db $0C,$F4
YAcceleration:
	db $01,$FF
frm:
    db $02,$03,$04,$05,$04,$03	
frmfly:
    db $06,$09,$08,$07	
frmhurt:
    db $0A,$0B	
Xspd:
    db $18,$E8	
Xspd2:
    db $30,$D0 	
Flyingattacks:
	db $02,$02,$02
	
    
print "INIT ",pc
    PHB
	PHK
	PLB
	%SubHorzPos()
	TYA
	STA !157C,x
	STZ !1504,x	
	LDY #$01
	JSR EXTRA
	and #$0F
	sta !1534,x	
	LDY #$03
	JSR EXTRA
	and #$0F
	sta !1602,x	
	LDY #$03
	JSR EXTRA
	and #$F0
	lsr
	sta !extra_byte_4,x	
	LDY #$01
	JSR EXTRA
	and #$F0
	beq +
	bra ++
	+
	lda #$60
	++
	STA !154C,x
	sta !1626,x
	.return4
	PLB
	RTL

print "MAIN ",pc
	PHB
	PHK
	PLB
	LDA !C2,x
	CMP #$07
	BCS .Sphere
	JSR Run
	PLB
	RTL

.Sphere	
	JSR Run_Sphere
	PLB
	RTL

Return:
	RTS

	EXTRA:
	LDA !extra_byte_1,x
	STA $00
	LDA !extra_byte_2,x
	STA $01
	LDA !extra_byte_3,x
	STA $02
	LDA [$00],y
	RTS

Run:
	JSR Graphics 
	LDA $9D
	BNE Return
	LDA !14C8,x
	CMP #$08
	BNE Return
	LDA #$00
	%SubOffScreen()
	LDA !C2,x
	JSL $0086DF
	DW .boomstart1
	DW .boomstart2
	DW .boom1
	DW .boom2
	DW .boom3
	DW .boomhurt
	DW .boomdead

.sides
	LDA !B6,x
	EOR #$FF
	STA !B6,x
	RTS
.thing1234
	INC !1528,x
	JSL $01AA33
	JSL $01AB99
	LDA #$28
	STA $1DFC|!addr
	LDA #$02
	STA $1DF9|!addr
	LDY #$00
	JSR EXTRA
	and #$F0			; only check for its health bits
	lsr #4				; shift accordingly
	cmp #$00			; if it's 0, just use vanilla behaviour.
	bne .novanilla
	lda #$03
	.novanilla
	sta $00				; store
	LDA !1528,x
	CMP $00				;Health (Do NOT touch! Unless you know what you're doing!)
	BCS .stof2
	LDA #$05
	STA !C2,x				;Hurt State
	STZ !B6,x
	stz !AA,x
	LDA #$60
	STA !154C,x
	RTS
.stof2
	LDA #$06
	STA !C2,x				;Dead State
	STZ !B6,x
	stz !AA,x
	LDA #$B0
	STA !1540,x
	RTS
.int
	JSL $01A7DC
	BCS .hurt
	RTS
.hurt
	%SubVertPos()
	LDA $0E
	CMP #$E6
	BMI .thing1234
	JSL $00F5B7
	RTS
.boom1
	JSL $01802A
	JSR .int
	JSL $019138
	LDA !1588,x
	AND #$03
	BEQ +
	JMP .sides
	+
	LDA !151C,x
	LSR A
	TAY
	LDA frm,y
	STA !1504,x
	LDA $14
	AND #$03
	BNE .change
	RTS
.change
	LDA !151C,x
	CMP #$0A
	BNE .thing1
	STZ !151C,x
	RTS
.random
JSL $01ACF9 ;random number routine
	EOR $13 ; frame counter 1
	ADC $14 ; frame counter 2 (pauses when game paused)
	sbc $94
	adc $00
	eor $01
	sbc $02
	eor $0F32|!addr
	adc $0F33|!addr
	rts
.thing1
	INC !151C,x
	RTS
.thing4567
	JSL $00F5B7
	RTS
.boomstart1
	JSL $01802A
	JSL $01A7DC	; if in contact, damage
	BCS .thing4567
	STZ !1504,x
	LDA !154C,x	; counter till next phase
	BEQ .thing2
	RTS
.thing2
	INC !C2,x
	LDA #$0A
	STA !154C,x	
	lda !160E,x
	bit #$01
	bne .fire
	.check
	bit #$02
	bne .bobomb
	.return
	stz !160E,x
	stz !1594,x
	rts
	.bobomb
	lda #!spritenumber
	sta $0D
	LDY #$00
	JSR EXTRA
	and #$08
	beq +
	lda #$0D
	sta $0D
	+
	ldy #$01
	.spriteloop
	lda SpriteXSpeed,y
	sta $02
	stz $00
	stz $01
	lda SpriteYSpeed,y
	sta $03
	phy
	lda $0D
	clc					; change this to a SEC to make it spawn a custom sprite instead, altough then you won't be able to throw bob-ombs without modifying the code (it will throw custom sprite in the $0D slot).
	%SpawnSprite()
	lda $0D
	cmp #$0D
	bne .nobob
	lda !1686,y	; make sure they don't interact with each other
	ora #$08
	sta !1686,y
	LDA #$09
	STA !14C8,y
	LDA #!timer	; bob-ombs explosion timer.
	STA !1540,y		;/
	.nobob
	ply
	dey
	bpl .spriteloop
	bra .return
	.fire
	ldy #$03
	.fireloop
	stz $00
	stz $01
	lda FireXSpeed,y
	sta $02
	lda FireYSpeed,y
	sta $03
	lda #$0C
	phy
	clc
	%SpawnExtended()
	ply
	dey
	bpl .fireloop
	lda !160E,x
	jmp .check

.boomstart2
	JSL $01802A
	JSL $01A7DC
	BCC +
	JMP .thing4567
	+
	LDA #$01
	STA !1504,x
	LDA !154C,x
	BEQ .thing3
	RTS

.thing3
	LDY #$00
	JSR EXTRA
	bit #$04
	beq .nonrandom
	jsr .random
	and #$07
	tay
	lda Randomphases,y
	bra .nonvanilla
	.nonrandom
	and #$03
	cmp #$03
	bne .nonvanilla
	lda !1528,x						; still use health as base (as the vanilla version)
	and #$0F
	tay
	lda Healthphases,y
	.nonvanilla	
	
	JSL $0086DF				;Use a pointer!
	dw .INIT1				;Walking
	dw .INIT2				;Flying
	dw .INIT3				;Running + Jumping


.INIT1
	%SubHorzPos()
	TYA
	STA !157C,x
	LDA #$02
	STA !C2,x				;Walking State
	LDA #$10
	STA !154C,x
	LDY !157C,x
	lda !extra_byte_4,x
	beq +
	sta $0D
	eor #$FF
	inc
	sta $0E	
	lda $0D,y
	bra ++
	+
	LDA Xspd,y
	++
	STA !B6,x
	LDA #$D0
	STA !AA,x
	RTS

.INIT2

if !random
lda !1FD6,x	
bne .yes
	jsr .random
	and #$01
	bra .slop
	.yes
	%SubHorzPos()
	TYA
	.slop
else
	%SubHorzPos()
	TYA
endif
	STA !157C,x
	LDA #$03
	STA !C2,x				;Flying State
	LDA #$10
	STA !154C,x
	LDA #$C0
	STA !AA,x
	stz !1570,x
	stz !187B,x
lda #$F0
sta $06
LDY #$06
JSR EXTRA
pha
and #$F0
beq +
sta $06
+
pla
and #$0F
sta $07
lda !1528,x
beq +
sec
sbc #$01
sta $00
.loop99
lda $06
sec
sbc $07
bcc +
sta $06
dec $00
bpl .loop99
+	
lda $06
cmp #$10
bcs +
lda #$10
sta $06
+
lda $06
	STA !163E,x
	LDY !157C,x	
	lda !extra_byte_4,x
	beq +
	sta $0D
	eor #$FF
	inc
	sta $0E	
	lda $0D,y
	bra ++
	+
	LDA Xspd,y
	++
	STA !B6,x
	RTS

.INIT3
	LDY #$04
	JSR EXTRA
	and #$F0
	beq .skipo
	sta $0B
	LDY #$04
	JSR EXTRA
	and #$0F
	sta $0C	
lda !1528,x
beq .joj4
sec
sbc #$01
sta $00
.loop884
lda $0B
sec
sbc $0C
bcc .joj4
sta $0B
dec $00
bpl .loop884
.joj4
lda $0B
cmp #$20
bcs .nol523
lda #$20
sta $0B
.nol523
LDA $0B
sta !15AC,x
.skipo
	%SubHorzPos()
	TYA
	STA !157C,x
	LDA #$04
	STA !C2,x				;Jumping State
	LDA #$10
	STA !154C,x
	LDY !157C,x
	lda !extra_byte_4,x
	beq +
	sta $0D
	eor #$FF
	inc
	sta $0E	
	lda $0D,y
	bra ++
	+
	LDA Xspd2,y
	++
	STA !B6,x
	LDY #$06
	JSR EXTRA
	and #$F0
	beq .heavyrou
	sta $0E
	LDY #$06
	JSR EXTRA
	and #$0F
	sta $0F
lda !1528,x
beq .joj8
sec
sbc #$01
sta $00
.loop8868
lda $0E
sec
sbc $0F
bcc .joj8
sta $0E
dec $00
bpl .loop8868
.joj8
lda $0E
cmp #$20
bcs .nol5
lda #$20
sta $0E
.nol5
lda $0E
	STA !163E,x
	LDA #$C0
	STA !AA,x
.heavyrou
RTS

.boom2
	JSR .int
	LDA $14
	LSR A
	LSR A
	AND #$03
	TAY
	LDA frmfly,Y
	STA !1504,x
	JSL $019138
	LDA !1588,x
	AND #$03
	BNE .Str23
	bra +
	.Str23
	LDA !B6,x
	EOR #$FF
	STA !B6,x
	RTS
	+
	JSL $01801A
	JSL $018022
lda !1570,x
JSL $0086DF
dw .normalfly
dw .select
dw .ram

.ram
LDY #$04
JSR EXTRA
and #$F0
beq +
sta $05
eor #$FF
inc
sta $06
bra ++
+
lda #$20
sta $05
lda #$E0
sta $06
++
LDY #$04
JSR EXTRA
and #$0F
sta $07
lda !1528,x
beq +
sec
sbc #$01
sta $00
.loop88
lda $05
clv
clc
adc $07
bvs +
sta $05
lda $06
sec
sbc $07
sta $06
dec $00
bpl .loop88
+
lda $05
cmp #$20
bcc +
lda #$20
sta $05
lda #$E0
sta $06
+
lda $96
pha
lda $97
pha
rep #$20
lda $96
sec
sbc #$0010
sep #$20
%SubVertPos()
pla
sta $97
pla 
sta $96

LDA !AA,x			; load speed
CMP $05,y		; \ compare it with the maximum speed
BEQ +				; / and branch if it's not equal
LDA !AA,x			; \
CLC					; | load Y speed, add the acceleration
ADC YAcceleration,y	; | and store it
STA !AA,x			; /
+
%SubHorzPos()
LDA !B6,x		; set the X speed depending on direction
CMP $05,y
BEQ +
lda !B6,x
CLC
ADC YAcceleration,y
STA !B6,x
+
rts
.normalfly
LDY #$05
JSR EXTRA
and #$F0
lsr #4
beq +
sta $00

lda !1528,x
cmp $00
bcc +
	lda $14
	and #$1F
	bne +
	stz $00
	stz $01
	stz $02
	stz $03
	lda #$0C
	clc
	%SpawnExtended()	
	+
	LDA !1FD6,x				;Load... something
	AND #$01				;AND #$01
	TAY						;Use as index for acceleration table
	LDA !AA,x				;\ 
	CLC						; |Load Y speed
	ADC YAcceleration,y		; |Accelerate it
	STA !AA,x				;/
	CMP YSpeedtable,y		;If it didn't reach the desired Y speed
	BNE .Straight			;Continue processing the sprite
	INC !1FD6,x				;If it reached the desired speed, change Y direction

.Straight

lda !163E,x
bne +

inc !1570,x

	lda #$40
	sta $0E
	
	LDY #$01
	JSR EXTRA
	and #$F0
	beq +++++
	sta $0E
	+++++
	LDY #$01
	JSR EXTRA
	and #$0F
	sta $0F
lda !1528,x
beq .joj2
sec
sbc #$01
sta $00
.loop8865
lda $0E
sec
sbc $0F
bcc .joj2
sta $0E
dec $00
bpl .loop8865
.joj2

lda $0E
cmp #$20
bcs .nol4
lda #$20
sta $0E
.nol4
++
lda $0E
sta !163E,x
+

rts

.select

stz !AA,x
stz !B6,x

	LDY #$00
	JSR EXTRA
	and #$F0			; only check for its health bits
	lsr #4				; shift accordingly
	cmp #$00			; if it's 0, just use vanilla behaviour.
	bne .novanilla255
	lda #$03
	.novanilla255
	sta $00				; store

	lda #!bobnumber
	sta $01
	
	LDA !1528,x
	clc
	adc #$01
	CMP $00				;Health (Do NOT touch! Unless you know what you're doing!)
	bne .different1
	lda #!bobnumber2
	sta $01
	.different1

lda !187B,x
cmp $01
beq .ramm

lda #$01
sta !1594,x

LDY #$05
JSR EXTRA
and #$0F
bne .pse78
jmp .ramm
.pse78
sta $0D

lda !1528,x
cmp $0D
bcs .pse278
jmp .ramm
.pse278

bra .noram

.ramm

lda #$02
sta !1594,x

.noram

lda !163E,x
beq .skip
jmp +
.skip

stz !1594,x

LDY #$05
JSR EXTRA
and #$0F
bne .pse
jmp ++
.pse
sta $0D

lda !1528,x
cmp $0D
bcs .pse2
jmp ++
.pse2
	LDY #$00
	JSR EXTRA
	and #$F0			; only check for its health bits
	lsr #4				; shift accordingly
	cmp #$00			; if it's 0, just use vanilla behaviour.
	bne .novanilla2
	lda #$03
	.novanilla2
	sta $00				; store
		
	lda #!bobnumber
	sta $01
	
	LDA !1528,x
	clc
	adc #$01
	CMP $00				;Health (Do NOT touch! Unless you know what you're doing!)
	bne .different
	lda #!bobnumber2
	sta $01
	.different
	

lda !187B,x
cmp $01
beq ++

inc !187B,X
	lda #!spritenumber
	sta $0F
	LDY #$00
	JSR EXTRA
	and #$08
	beq .noby
	lda #$0D
	sta $0F
	.noby

stz $02
	stz $00
	stz $01
	stz $03
	lda $0F
	clc					; change this to a SEC to make it spawn a custom sprite instead, altough then you won't be able to throw bob-ombs without modifying the code (it will throw custom sprite in the $0D slot).
	%SpawnSprite()
	lda $0F
	cmp #$0D
	bne .nobob2
	lda !1686,y	; make sure they don't interact with each other
	ora #$08
	sta !1686,y
	LDA #$09
	STA !14C8,y
	LDA #!timer	; bob-ombs explosion timer.
	STA !1540,y		;/
	.nobob2

lda !187B,x
pha
jsr .INIT2
pla
sta !187B,x

stz !AA,x
bra +
++

lda #$02
sta !1570,x

stz !163E,x
+
	rts

.boom3
	JSR .boom1
	LDA !163E,x
	BEQ .joomper
	.yup
	LDY #$04
	JSR EXTRA
	AND #$F0
	BEQ .notransition
	lda !15AC,x
	bne .notransition
	stz !B6,x
	stz !AA,x

	jsr .newthings
	
	
	.notransition
	RTS

.joomper
	
	lda #$80
	sta $0E
	
	LDY #$06
	JSR EXTRA
	and #$F0
	beq .heavyreturn
	sta $0E

	LDY #$06
	JSR EXTRA
	and #$0F
	sta $0F
	
lda !1528,x
beq .joj
sec
sbc #$01
sta $00
.loop886
lda $0E
sec
sbc $0F
bcc .joj
sta $0E
dec $00
bpl .loop886
.joj

lda $0E
cmp #$20
bcs .nol
lda #$20
sta $0E
.nol

lda $0E
	STA !163E,x
	
	
	LDA #!jump
	STA !AA,x
	
	.heavyreturn
	bra .yup

.boomhurt
	stz !B6,x
	
	stz !1FD6,x
	JSL $01802A
	LDA !154C,x
	BEQ .thing4
	LDA $14
	LSR A
	LSR A
	AND #$01
	TAY
	LDA frmhurt,y
	STA !1504,x
	RTS

.newthings

	STZ !C2,x
	STZ !1504,x
	lda !1626,x
	sta !154C,x
	bra .oldthings

.thing4
	STZ !C2,x
	STZ !1504,x
	
	lda !1626,x
	sec
	sbc !1534,x
	bcc ++
	cmp #$06
	bcs +
	++
	lda #$05
	+
	sta !1626,x
	STA !154C,x
	
	lda !extra_byte_4,x
	beq +
	clc
	adc !1602,x
	bpl +
	lda #$7F
	+
	sta !extra_byte_4,x
	
	.oldthings
	
	stz $0D
	
	lda !1528,x
	clc
	adc #$01
	sta $0E
	
	LDY #$02
	JSR EXTRA
	and #$0F
	beq +
	cmp $0E
	bcs +
	lda $0D
	ora #$01
	sta $0D
	+
	LDY #$02
	JSR EXTRA
	and #$F0
	beq +
	lsr #4
	cmp $0E
	bcs +
	lda $0D
	ora #$02
	sta $0D
	+
	
	lda #$03
	and $0D
	beq +
	pha
	lda #$01
	sta !1594,x
	pla
	+
	sta !160E,x
	.return5
	RTS

.boomdead
stz !B6,x
	JSL $01802A

	LDA !1540,x
	BEQ .STOOF

	LDA #$0A
	STA !1504,x
	RTS

.STOOF
	STZ !14C8,x

	LDA #$10
	STA $1DF9|!addr

	JSR .drawsmoke

	LDA !186C,x
	BNE .EndSpawn
	
	JSL $02A9DE
	BMI .EndSpawn

	LDA #$01
	STA !14C8,y

	LDA !7FAB9E,x
	PHX
	TYX
	STA !7FAB9E,x
	PLX

	LDA !E4,x
	STA.w !E4,y
	LDA !14E0,x
	STA !14E0,y
	LDA !D8,x
	STA.w !D8,y
	LDA !14D4,x
	STA !14D4,y

	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7

	LDA #$08
	STA !7FAB10,x
	LDA #$07
	STA !C2,x
	LDA #$B8
	STA !AA,x
	PLX

.EndSpawn
	RTS

.drawsmoke
	LDY #$03
-	LDA $17C0|!addr,y
	BEQ +
	DEY
	BPL -
	RTS

+	LDA #$01
	STA $17C0|!addr,y
	LDA #$1C     
	STA $17CC|!addr,y
	LDA !D8,x
	STA $17C4|!addr,y
	LDA !E4,x
	STA $17C8|!addr,y

return2:
	RTS

Run_Sphere:
    JSR SUB_GFX

    JSL $01802A

    LDA $9D
    BNE return2

    JSR ContactSph

    LDA $14
    AND #$08
    BNE .STOOOOOFF

    RTS

.STOOOOOFF
	JSL $01ACF9             ; \ set random routine
	AND #$0F                ; /
	CLC                     ;
	LDY #$00                ; \ set x location (low and high byte)
	ADC #$FC                ;  |
	BPL SKIP                ;  |
	DEY                     ;  |
SKIP:
	CLC                     ;  |
	ADC !E4,x               ;  |
	STA $02                 ;  |
	TYA                     ;  |
	ADC !14E0,x             ; /
	PHA                     ; 
	LDA $02                 ; \ set position in the screen
	CMP $1A                 ;  |
	PLA                     ;  |
	SBC $1B                 ; /
	BNE RETURN2             ; 
	LDA $148E|!addr			; \ set y location (low byte) 
	AND #$0F                ;  |
	CLC                     ;  |
	ADC #$FE                ;  |
	ADC !D8,x               ;  |
	STA $00                 ; /
	LDA !14D4,x             ; \ set y location (high byte)
	ADC #$00                ;  |
	STA $01                 ; /
	JSR DISPLAY_SPARKLE     ; display sparkle routine

RETURN2:
	RTS                     ; return

ContactSph:
	JSL $01A7DC
	BCC RETURN2

	LDA #$FF
	STA $1493|!addr
	LDA #!GoalMusic
	STA $1DFB|!addr
	STZ !14C8,x
	DEC $13C6|!addr
	RTS


DISPLAY_SPARKLE:
	LDY #$0B                ; \ find a free slot to display effect
FINDFREE:
	LDA $17F0|!addr,y		;  |
	BEQ FOUNDONE            ;  |
	DEY                     ;  |
	BPL FINDFREE            ;  |
	RTS                     ; / return if no slots open

FOUNDONE:
	LDA #$05                ; \ set effect graphic to sparkle graphic
	STA $17F0|!addr,y		; /
	LDA #$00                ; \ set time to show sparkle
	STA $1820|!addr,y		; /
	LDA $00                 ; \ sparkle y position
	STA $17FC|!addr,y		; /
	LDA $02                 ; \ sparkle x position
	STA $1808|!addr,y		; /
	LDA #$17                ; \ load generator x position and store it for later
	STA $1850|!addr,y		; /
	RTS                     ; return

SUB_GFX:
	%GetDrawInfo()

	LDA $00
	STA $0300|!addr,y

	LDA $01
	STA $0301|!addr,y

	LDA #!GoalTile
	STA $0302|!addr,y

	LDA #!GoalProp
	ORA $64
	STA $0303|!addr,y

	INY
	INY
	INY
	INY

	LDY #$02
	LDA #$00
	JSL $01B7B3
	RTS

Tilemap: 
db $00,$02,$20,$22
db $04,$06,$24,$26
db $08,$0A,$28,$2A
db $0C,$0E,$2C,$2E
db $40,$42,$60,$62
db $44,$46,$64,$66
db $80,$82,$A0,$A2
db $88,$8A,$A8,$AA
db $C0,$C2,$E0,$E2
db $C4,$C6,$E4,$E6
db $48,$4A,$68,$6A
db $4C,$4E,$6C,$6E

X_Position:
    db $F8,$08,$F8,$08

Y_Position:
    db $F0,$F0,$00,$00

Properties:
    db $0F,$0F,$0F,$0F

Graphics:
	%GetDrawInfo()
	LDA !1504,x
	ASL A
	ASL A
	STA $02
	lda !1594,x
	sta $04
	LDA !1540,x
	STA $03
	PHX
	LDX #$03
Loop:
	LDA $00
	CLC
	ADC X_Position,x
	STA $0300|!addr,y
	LDA $01
	CLC
	ADC Y_Position,x
	STA $0301|!addr,y
	PHX
	TXA
	CLC
	ADC $02
	TAX
	LDA Tilemap,x
	STA $0302|!addr,y
	PLX
	LDA Properties,x
	ORA $64
	STA $0303|!addr,y
	LDA $03
	BEQ .thing
	LDA $14
	LSR A
	AND #$07
	PHX
	TAX
	LDA $0303|!addr,y
	AND #$F1
	ORA FlashTbl,x
	STA $0303|!addr,y
	PLX
.thing
	lda $04
	beq .det
	cmp #$01
	beq .red
	cmp #$02
	beq .blue
	bra .det
	.red
	LDA $14
	LSR A
	AND #$07
	PHX
	TAX
	LDA $0303|!addr,y
	AND #$F1
	ORA FlashTbl2,x
	STA $0303|!addr,y
	plx
	bra .det
	.blue
	LDA $14
	LSR A
	AND #$07
	PHX
	TAX
	LDA $0303|!addr,y
	AND #$F1
	ORA FlashTbl3,x
	STA $0303|!addr,y
	plx
	.det
	INY
	INY
	INY
	INY
	DEX
	BPL Loop
	PLX
	LDY #$02
	LDA #$03
	JSL $01B7B3
	RTS

FlashTbl:
	db $04,$04,$06,$06,$08,$08,$0A,$0A
FlashTbl2:
	db $04,$04,$08,$08,$04,$04,$08,$08
FlashTbl3:
	db $06,$06,$04,$04,$06,$06,$04,$04